import { ContainerType, EffectTriggerTiming } from "../../types";
import { SupportedEaseNameToCubicBezier } from "@zyzgroup/core-web";
export type SupportedCSSAnimation = "jelly" | "bounce" | "flash" | "pulse" | "rubberBand" | "shakeX" | "shakeY" | "headShake" | "swing" | "tada" | "wobble" | "jello" | "heartBeat" | "backInLeft" | "backInRight" | "backInUp" | "backInDown" | "backOutLeft" | "backOutRight" | "backOutUp" | "backOutDown" | "bounceIn" | "bounceInLeft" | "bounceInRight" | "bounceInUp" | "bounceInDown" | "bounceOut" | "bounceOutLeft" | "bounceOutRight" | "bounceOutUp" | "bounceOutDown" | "fadeIn" | "fadeInLeft" | "fadeInLeftBig" | "fadeInRight" | "fadeInRightBig" | "fadeInUp" | "fadeInUpBig" | "fadeInDown" | "fadeInDownBig" | "fadeInTopLeft" | "fadeInTopRight" | "fadeInBottomLeft" | "fadeInBottomRight" | "fadeOut" | "fadeOutLeft" | "fadeOutLeftBig" | "fadeOutRight" | "fadeOutRightBig" | "fadeOutUp" | "fadeOutUpBig" | "fadeOutDown" | "fadeOutDownBig" | "fadeOutTopLeft" | "fadeOutTopRight" | "fadeOutBottomRight" | "fadeOutBottomLeft" | "flip" | "flipInX" | "flipInY" | "flipOutX" | "flipOutY" | "flipOutRight" | "flipInLeft" | "flipOutLeft" | "flipInRight" | "flipOutTop" | "flipInBottom" | "flipOutBottom" | "flipInTop" | "lightSpeedInLeft" | "lightSpeedInRight" | "lightSpeedOutLeft" | "lightSpeedOutRight" | "rotateIn" | "rotateInUpLeft" | "rotateInUpRight" | "rotateInDownLeft" | "rotateInDownRight" | "rotateOut" | "rotateOutUpLeft" | "rotateOutUpRight" | "rotateOutDownLeft" | "rotateOutDownRight" | "hinge" | "rotateFall" | "rotateOutNewspaper" | "rotateInNewspaper" | "jackInTheBox" | "rollIn" | "rollOut" | "zoomIn" | "zoomInLeft" | "zoomInRight" | "zoomInUp" | "zoomInDown" | "zoomOut" | "zoomOutLeft" | "zoomOutRight" | "zoomOutUp" | "zoomOutDown" | "fade" | "moveFromLeft" | "moveToLeft" | "moveFromRight" | "moveToRight" | "moveFromTop" | "moveToTop" | "moveFromBottom" | "moveToBottom" | "moveFromLeftFade" | "moveToLeftFade" | "moveFromRightFade" | "moveToRightFade" | "moveFromTopFade" | "moveToTopFade" | "moveFromBottomFade" | "moveToBottomFade" | "scaleFromSmall" | "scaleToSmall" | "scaleFromLarge" | "scaleToLarge" | "scaleFromSmallCenter" | "scaleToSmallCenter" | "slideInLeft" | "slideInRight" | "slideInUp" | "slideInDown" | "slideOutLeft" | "slideOutRight" | "slideOutUp" | "slideOutDown" | "rotateRightSideFirst" | "rotateLeftSideFirst" | "rotateTopSideFirst" | "rotateBottomSideFirst" | "rotatePushLeft" | "rotatePushRight" | "rotatePushTop" | "rotatePushBottom" | "rotatePullRight" | "rotatePullLeft" | "rotatePullTop" | "rotatePullBottom" | "rotateFoldRight" | "rotateFoldLeft" | "rotateFoldTop" | "rotateFoldBottom" | "rotateUnfoldLeft" | "rotateUnfoldRight" | "rotateUnfoldTop" | "rotateUnfoldBottom" | "rotateRoomLeftOut" | "rotateRoomLeftIn" | "rotateRoomRightOut" | "rotateRoomRightIn" | "rotateRoomTopOut" | "rotateRoomTopIn" | "rotateRoomBottomOut" | "rotateRoomBottomIn" | "rotateCubeLeftOut" | "rotateCubeLeftIn" | "rotateCubeRightOut" | "rotateCubeRightIn" | "rotateCubeTopOut" | "rotateCubeTopIn" | "rotateCubeBottomOut" | "rotateCubeBottomIn" | "rotateCarouselLeftOut" | "rotateCarouselLeftIn" | "rotateCarouselRightOut" | "rotateCarouselRightIn" | "rotateCarouselTopOut" | "rotateCarouselTopIn" | "rotateCarouselBottomOut" | "rotateCarouselBottomIn" | "rotateSidesOut" | "rotateSidesIn" | "rotateSlideOut" | "rotateSlideIn" | "superRainbow" | "statusProcessing";
declare const _default: __VLS_WithTemplateSlots<import("vue").DefineComponent<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToOption<{
    containerType?: ContainerType;
    supportCopyText?: boolean;
    effectTriggerTiming?: EffectTriggerTiming;
    name?: SupportedCSSAnimation;
    timingFunction?: SupportedEaseNameToCubicBezier;
    duration?: number;
    delay?: number;
    repeat?: number | "infinite";
    direction?: "reverse" | "normal" | "alternate" | "alternate-reverse";
    fillMode?: "none" | "both" | "forwards" | "backwards";
    playState?: "running" | "paused";
    perspective?: string;
}>, {
    containerType: string;
    supportCopyText: boolean;
    effectTriggerTiming: string;
    name: string;
    fillMode: string;
    playState: string;
    perspective: string;
}>>, {
    trigger: (newAnimationName?: SupportedCSSAnimation) => void;
    triggerReverse: (newAnimationName?: SupportedCSSAnimation) => void;
    clear: () => void;
}, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    cssanimationstart: (name: string) => void;
    cssanimationend: (name: string) => void;
}, string, import("vue").PublicProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToOption<{
    containerType?: ContainerType;
    supportCopyText?: boolean;
    effectTriggerTiming?: EffectTriggerTiming;
    name?: SupportedCSSAnimation;
    timingFunction?: SupportedEaseNameToCubicBezier;
    duration?: number;
    delay?: number;
    repeat?: number | "infinite";
    direction?: "reverse" | "normal" | "alternate" | "alternate-reverse";
    fillMode?: "none" | "both" | "forwards" | "backwards";
    playState?: "running" | "paused";
    perspective?: string;
}>, {
    containerType: string;
    supportCopyText: boolean;
    effectTriggerTiming: string;
    name: string;
    fillMode: string;
    playState: string;
    perspective: string;
}>>> & Readonly<{
    onCssanimationstart?: (name: string) => any;
    onCssanimationend?: (name: string) => any;
}>, {
    name: SupportedCSSAnimation;
    perspective: string;
    containerType: ContainerType;
    supportCopyText: boolean;
    effectTriggerTiming: EffectTriggerTiming;
    fillMode: "none" | "both" | "forwards" | "backwards";
    playState: "running" | "paused";
}, {}, {}, {}, string, import("vue").ComponentProvideOptions, true, {}, any>, {
    default?(_: {}): any;
}>;
export default _default;
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToOption<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
